{ TEST program for the ZIP File System unit (ZFS) - Ivn Montes Velencoso

   WWW : http://webs.demasiado.com/freakpascal/
   e-mail : senbei@teleline.es

    Needs an external file called TEST.ZIP that contains a simple typed
    file called 'RECZIP.DAT' which is stored using method 8.
}

{.$DEFINE CREATE}   //if defined creates a new file

uses crt, dos, ZFS;

type
  tAddress =packed record
    Name :String[20];    {Lastname, Firstname}
    Addr :String[20];    {street, number}
    Tlf  :String[10];    {telephone}
    email:String[30];    {e-mail}
  end;

var
  pack1     :pZIP;
  f         :file of tAddress;
  rec       :tAddress;

begin
  WriteLN(' ZiP File System - Test Program');
  WriteLN('.----------------------------.');
  WriteLN;

  pack1:=OpenZIP('TEST.ZIP', normalmode);

  assign(f, 'RECZIP.DAT');


  {$IFDEF CREATE}

  Write('Creating RECZIP.DAT file...');
  rewrite(f);
  rec.Name :='Montes, Ivn';
  rec.Addr :='Edison, 48';
  rec.Tlf  :='938143315';
  rec.email:='drslump@mundomail.net';
  write(f, rec);

  rec.Name :='Smith, Steve';
  rec.Addr :='Longbeach, 126';
  rec.Tlf  :='555-5423';
  rec.email:='ssmith@mymail.com';
  write(f, rec);

  rec.Name :='Vernuilli, Angelo';
  rec.Addr :='Pizzoreto, 14';
  rec.Tlf  :='32-327425';
  rec.email:='mailme@italyonline.it';
  write(f, rec);

  WriteLN('Done');
  {$ELSE}

  reset(f, sizeof(tAddress));
  if filerec(f).mode=fmZipped then WriteLN('READING FROM A ZIP - Press a key')
                              else WriteLN('READING FROM DISK - Press a key');
  readkey;
  ClrScr;

  While NOT(eof(f)) do
   begin
     read(f, rec);
     WriteLN('Name    : ', rec.Name);
     WriteLN('Address : ', rec.Addr);
     WriteLN('Tlf.    : ', rec.tlf);
     WriteLN('e-mail  : ', rec.email);
     WriteLN;
     WriteLN('Press a key to view next record');
     readkey;
     ClrScr;
   end;

  {$ENDIF}

  close(f);
end.