Program ZFS_Seeking_Optimizer;
{$MODE OBJFPC}
{$ASMMODE intel}

{$I DEFINES.INC}

{$IFNDEF ZFS_SEEKING_INFO}
  -- You need to compile the Unzip unit with this define activated to could
     compile the ZFS Seeking Optimizer --
{$ENDIF}

Uses Crt, Dos, HtScreen, Unzip;

Const
  ProgName = 'ZFS SEEKING OPTIMIZER';
  ProgVer = 'v0.1b';
  ProgAuthor = 'Ivn Montes aka Dr.Slump';
  ProgDate = '10-MAY-99';


VAR
  OldScreen :ARRAY[1..50,1..80] OF WORD;  {backup of old Dos screen}
  OldCurX,
  OldCurY   :Byte;

  omzfile   :file;

  ZipName   :String;
  OMZName   :String;
  TempFile  :String;



Procedure InitScreen;
begin
  {Stores backup screen information}
  HtStoreToMem(1,1,CrtRows,CrtCols, OldScreen);
  OldCurX:=WhereX;
  OldCurY:=WhereY;
  SetCursor(CursorOff);
end;

Procedure CloseScreen;
begin
  {Restores the backup screen information}
  HtStoreToScr(1,1,CrtRows,CrtCols, OldScreen);
  GoToRC(OldCurY, OldCurX);
  SetCursor(CursorInitial);
end;

Procedure DrawBackground;
begin
  HtFill(1,1,CrtRows,CrtCols, LightGray+BlueBG, '');
  HtFill(1,1,1,CrtCols, Yellow+BlueBG, ' ');
  HtWrite(1,1, Yellow+BlueBG, ProgName+' '+ProgVer+' by '+ProgAuthor+' ['+ProgDate+']');
  HtFill(25,1,25,CrtCols, Black+LightGrayBG, ' ');
end;


Function MainMenu :Longint;
var
  back :array[1..25,1..80] of Word;
  item :longint;
  done :boolean;
  msg  :string;
  ch   :char;
begin
  Result:=0;
  item:=1;
  done:=false;

  ZipName:='';
  OMZName:='';

  HtStoreToMem(1,1,CrtRows,CrtCols, back);

  Box(10,20,3,40, Black+LightGrayBG, SingleBorder, ' ');
  HtWriteC(10,40, Black+LightGrayBG, 'Select ZIP');
  HtWriteC(11,40, Black+LightGrayBG, 'Edit OMZ');
  HtWriteC(12,40, black+LightGrayBG, 'Exit');

  Repeat
    case item of {Calculate bottom message}
      1 :msg:='Select a ZIP file to process';
      2 :msg:='Edit an existing OptiMiZation file';
      3 :msg:='Exits from ZFS Seeking Optimizer';
      else msg:='Invalid ITEM';
    end; {case}

    HtFill(25,1,25,CrtCols, Black+LightGrayBG, ' ');
    HtAttr(10,20,1,40, Black+LightGrayBG);
    HtAttr(11,20,1,40, Black+LightGrayBG);
    HtAttr(12,20,1,40, Black+LightGrayBG);

    HtAttr(9+item,20,1,40, White+BlueBG);
    HtWrite(25, 1, Black+LightGrayBG, msg);


    ch:=htreadkey(fk);
    case ch of
      #27  :done:=true;         {Escape}
      #13  :begin               {Enter}
              done:=true;
              result:=1+item;
            end;
      #72  :begin               {Up Arrow}
              dec(item,1);
              if item<1 then item:=1;
            end;
      #80  :begin               {Down Arrow}
              inc(item,1);
              if item>3 then item:=3;
            end;
      #73  :begin               {PgUp}
              dec(item,5);
              if item<1 then item:=1;
            end;
      #81  :begin               {PgDn}
              inc(item,5);
              if item>3 then item:=3;
            end;
      #71  :begin               {HomeKey}
              item:=1;
            end;
      #79  :begin               {EndKey;}
              item:=3;
            end;
    end; {case}

  until Done=TRUE;

  if item=3 then result:=0;

  HtStoreToScr(1,1,CrtRows,CrtCols, back);
end;


Function SelectZIP :longint;
type
  pFile =^tFile;
  tFile =RECORD
    name :string;
    kind :longint;
    Size :DWord;
    date :DWord;
    next :pFile;
  end;

var
  ch   :char;
  back :array[1..25,1..80] of Word;
  done :boolean;
  res  :longint;
  filename :string;
  path :string;
  oldpath :string;
  FirstFile :pFile;
  CurrFile :pFile;
  TotalFiles :Longint;
  nowfile :longint;

  Procedure GetFiles;
  var
    DirInfo: SearchRec;
    tmp,tmp2 :pFile;
    f :file;
    a :array[0..3] of char;
  begin
    FindFirst('*.*', AnyFile, DirInfo); { Same as DIR *.* }
    while DosError = 0 do
     begin
       FillChar(a, 4, #0);
       if (DirInfo.Attr=Archive) then
        begin
          assign(f,DirInfo.Name);
          Reset(f, 1);
          BlockRead(f,a,4);
          Close(f);
        end;
       if ((a[0]=#80) AND (a[1]=#75) AND (a[2]=#3) AND (a[3]=#4)) OR
          ((DirInfo.Attr=Directory) AND NOT(DirInfo.Name='.')) then {a ZIP file or a directory}
        begin
          New(tmp);
          if FirstFile=NIL then FirstFile:=tmp
          else
           begin
             tmp2:=FirstFile;
             while tmp2^.next<>NIL do tmp2:=tmp2^.next;
             tmp2^.next:=tmp;
           end;

          tmp^.next:=NIL;
          tmp^.name:=DirInfo.Name;
          tmp^.kind:=DirInfo.Attr;
          tmp^.date:=DirInfo.Time;
          tmp^.size:=DirInfo.Size;
          inc(totalfiles,1);
        end;
       FindNext(DirInfo);
     end;
  end;

  Procedure ClearFiles;
  var tmp,tmp2:pFile;
  begin
    if Firstfile=NIL then exit;
    tmp:=FirstFile;
    while tmp<>NIL do
     begin
       tmp2:=tmp^.next;
       dispose(tmp);
       tmp:=tmp2;
     end;
    FirstFile:=NIL;
    TotalFiles:=0;
    NowFile:=1;
  end;

  Procedure ShowFiles(count:longint);
  var
    tmp :pFile;
    cc,i :longint;
  begin
    tmp:=FirstFile;
    if count>totalfiles then count:=totalfiles;
    if count<1 then count:=1;
    cc:=1;
    if count>11 then
     begin
       While tmp<>NIL do
        begin
          if cc>count-11 then break;
          inc(cc,1);
          tmp:=tmp^.next;
        end;
     end;

    i:=0;
    While (tmp<>NIL) AND (i<11) do
     begin
       if cc+i=count then
        begin
          if tmp^.kind=directory then
           htWrite(8+i,11,Yellow+CyanBG, '['+tmp^.name+']')
          else htWrite(8+i,11,Yellow+CyanBG, tmp^.name);
          HtAttr(8+i,11,1,55,White+GreenBG);
          CurrFile:=tmp;
        end
       else
        if tmp^.kind=directory then
         htWrite(8+i,11,Black+CyanBG, '['+tmp^.name+']')
        else htWrite(8+i,11,Black+CyanBG, tmp^.name);

       inc(i,1);
       tmp:=tmp^.next;
     end;
  end;


begin
  Result:=1;
  HtStoreToMem(1,1,CrtRows,CrtCols, back);

  Box(5,10,17,60, White+LightGrayBG, DoubleBorder, ' ');
  HtFill(20,10,2,60, Yellow+BlueBG, ' ');
  HtWrite(5,11, White+LightGrayBG, 'Name');

  FirstFile:=NIL;
  CurrFile:=NIL;
  TotalFiles:=0;
  GetDir(0, path);
  oldpath:=path;
  GetFiles;
  filename:='';
  Done:=FALSE;
  ch:=#0;
  res:=1;
  nowfile:=1;
  Repeat
    HtFill(6,11,1,24, Yellow+CyanBG, ' ');
    HtWrite(6,11, Yellow+CyanBG, filename);
    HtFill(20,10,2,60, Cyan+BlueBG, ' ');
    HtWrite(20,10, Cyan+BlueBG, Path);
    HtFill(8,11,11,55, Yellow+CyanBG, ' ');
    ShowFiles(nowfile);

    HtWrite(21,10, Cyan+BlueBg, CurrFile^.name);


    ch:=htReadKey(FK);
    case ch of
      #72  :begin               {Up Arrow}
              dec(nowfile,1);
              if nowfile<1 then nowfile:=1;
            end;
      #80  :begin               {Down Arrow}
              inc(nowfile,1);
              if nowfile>TotalFiles then nowfile:=totalfiles;
            end;

      #13  :begin
              if currfile^.kind=directory then
               begin
                 chdir(currfile^.name);
                 GetDir(0,path);
                 ClearFiles;
                 GetFiles;
               end
              else
               begin
                 Done:=TRUE;
                 Result:=10;  {To next steep}
                 if path[ord(path[0])] IN ['\','/'] then
                  ZipName:=path+currfile^.name
                 else ZipName:=path+'\'+currfile^.name;
               end;
            end;
      #27  :begin  {Escape}
              Done:=TRUE;
              Result:=1;  {Exit to Menu}
            end;
    end {case};
  Until DONE;

  chdir(oldpath);
  ClearFiles;

  HtStoreToScr(1,1,CrtRows,CrtCols, back);
end;

function GetOMZName :string;
var
  back :array[1..25,1..80] of word;
  getted :boolean;
  pos:byte;
  s:string;
  ch:char;
begin
  HtStoreToMem(1,1,CrtRows,CrtCols, back);
  result:='';
  s:='';
  pos:=1;
  getted:=FALSE;
  SetCursor(Cursorunderline);
  Repeat
    Box(7,10,3,60, White+MagentaBG, SingleBorder, ' ');
    HtWriteC(6,40, White+MagentaBG, ' Write a OMZ file to create ');
    HtFill(8,11,1,58, Yellow+BlueBG, ' ');
    HtWrite(8,11, White+BlueBG, s);

    GotoRC(8,10+pos);
    ch:=HtReadKey(FK);
    case ch of
      #33..#47,
      #58..#255,
      #48..#57  :begin
                   if (pos<60) AND NOT(FK) then
                    begin
                      s:=s+ch;
                      inc(pos,1);
                    end;
                 end;
      #8        :begin             {Backspace}
                   if pos>1 then
                    begin
                      Delete(s, length(s), 1);
                      dec(pos,1);
                    end;
                 end;
      #13       :begin             {Enter}
                   if s<>'' then
                    begin
                      if system.pos('.',s)=0 then s:=s+'.omz';
                      result:=s;
                      getted:=TRUE;
                    end
                   else
                    result:='default.omz';
                 end;
      #27       :begin             {Escape}
                   getted:=TRUE;
                 end;
    end;
  until getted;
  SetCursor(CursorOff);


  HtStoreToScr(1,1,CrtRows,CrtCols, back);
end;




var
  FirstOpti :pFileZip;

Procedure ClearOpti;
var tmp, tmp2 :pFileZip;
begin
  if FirstOpti=NIL then exit;
  tmp:=firstopti;
  While tmp<>NIL do
   begin
     tmp2:=tmp^.next;
     dispose(tmp);
     tmp:=tmp2;
   end;
end;


Function ProcessZIP :longint;
var
  back,back2 :array[1..25,1..80] of Word;
  done:boolean;
  CurrFile  :pFileZip;
  tmp :pFileZip;
  totalfiles :longint;
  nowfile :longint;
  ch :char;
  i :longint;

  Procedure GetOptimizables;
  var tmp,tmp2,tmp3 :pFileZip;
  begin
    if FirstFileZip=NIL then exit;
    tmp:=FirstFileZip;
    While tmp<>NIL do
     begin
       if (tmp^.kind=8) AND (tmp^.usize>32768) then
        begin
          new(tmp2);
          if FirstOpti=NIL then
           FirstOpti:=tmp2
          else
           begin
             tmp3:=FirstOpti;
             while tmp3^.next<>NIL do tmp3:=tmp3^.next;
             tmp3^.next:=tmp2;
           end;
          tmp2^.next:=NIL;
          tmp2^.Nom:=tmp^.Nom;
          tmp2^.Kind:=tmp^.kind;
          tmp2^.Pos:=tmp^.Pos;
          tmp2^.Size:=tmp^.Size;
          tmp2^.USize:=tmp^.USize;
          inc(totalfiles,1);
        end;
       tmp:=tmp^.next;
     end;
  end;

  Procedure ShowFiles(count:longint);
  var
    tmp :pFileZip;
    cc,i :longint;
  begin
    tmp:=FirstOpti;
    if count>totalfiles then count:=totalfiles;
    if count<1 then count:=1;
    cc:=1;
    if count>11 then
     begin
       While tmp<>NIL do
        begin
          if cc>count-11 then break;
          inc(cc,1);
          tmp:=tmp^.next;
        end;
     end;

    i:=0;
    While (tmp<>NIL) AND (i<11) do
     begin
       if cc+i=count then
        begin
          if tmp^.kind=8+16 then
           htWrite(8+i,11,Yellow+CyanBG, '[X] '+tmp^.nom)
          else htWrite(8+i,11,Yellow+CyanBG, '[ ] '+tmp^.nom);
          HtAttr(8+i,11,1,55,White+GreenBG);
          CurrFile:=tmp;
        end
       else
        if tmp^.kind=8+16 then
         htWrite(8+i,11,Black+CyanBG, '[X] '+tmp^.nom)
        else htWrite(8+i,11,Black+CyanBG, '[ ] '+tmp^.nom);

       inc(i,1);
       tmp:=tmp^.next;
     end;
  end;

var
  s :string;
begin
  result:=1;
  HtStoreToMem(1,1,CrtRows,CrtCols, back);

  totalfiles:=0;

  OpenZIP(Zipname);
  GetZIPfiles;
  Firstopti:=NIL;
  GetOptimizables;
  if FirstOpti=NIL then
   begin
     Box(12,20,3,40, White+RedBG, DoubleBorder, ' ');
     HtWriteC(13,40, White+RedBG, 'ERROR : NO OPTIMIZABLE FILES FOUND!');
     HtReadKey(FK);
     HtStoreToScr(1,1,CrtRows,CrtCols, back);
     CloseZIP;
     exit;
   end;

  HtWrite(25,1, Black+LightGrayBG, 'ESC : Main menu - SPACE : Select - F5 : Optimize');

  Box(5,10,17,60, White+LightGrayBG, DoubleBorder, ' ');
  HtFill(20,10,2,60, Yellow+BlueBG, ' ');

  CurrFile:=NIL;
  Done:=FALSE;
  ch:=#0;
  nowfile:=1;
  Repeat
    HtFill(20,10,2,60, Cyan+BlueBG, ' ');
    HtFill(8,11,11,55, Yellow+CyanBG, ' ');

    ShowFiles(nowfile);

    HtWrite(20,10, Cyan+BlueBg, CurrFile^.nom);
    str(CurrFile^.size,s);
    HtWrite(21,10, Cyan+BlueBg, 'Comp.Size: '+s);
    str(CurrFile^.usize,s);
    HtWrite(21,29, Cyan+BlueBg, 'UnComp.Size: '+s);


    ch:=htReadKey(FK);
    case ch of
      #72  :begin               {Up Arrow}
              dec(nowfile,1);
              if nowfile<1 then nowfile:=1;
            end;
      #80  :begin               {Down Arrow}
              inc(nowfile,1);
              if nowfile>TotalFiles then nowfile:=totalfiles;
            end;

      #32  :begin
              if currfile^.kind<>8+16 then currfile^.kind:=8+16
                                      else currfile^.kind:=8;
              inc(nowfile,1);
              if nowfile>TotalFiles then nowfile:=totalfiles;
            end;
      #63  :begin
              if FK then  {F5}
               begin
                 tmp:=FirstOpti;
                 i:=0;
                 While tmp<>NIL do
                  begin
                    if tmp^.kind=8+16 then inc(i,1);
                    tmp:=tmp^.next;
                  end;
                 if i=0 then
                  begin
                    HtStoreToMem(1,1,CrtRows,CrtCols, back2);
                    Box(12,20,3,40, White+RedBG, DoubleBorder, ' ');
                    HtWriteC(13,40, White+RedBG, 'ERROR : YOU HAVEN''T SELECTED ANY FILE!');
                    HtReadKey(FK);
                    HtStoreToScr(1,1,CrtRows,CrtCols, back2);
                  end
                 else
                  begin
                    done:=TRUE;
                    Result:=20;
                  end;
               end;
            end;
      #27  :begin  {Escape}
              Done:=TRUE;
              CloseZIP;
              Result:=1;  {Exit to Menu}
            end;
    end {case};
  Until DONE;

  HtStoreToScr(1,1,CrtRows,CrtCols, back);
end;

Procedure OpenCreateOMZFile;
var
  v:longint;
  s:string;
begin
  Assign(omzfile, OMZname);
  {$I-} reset(omzfile,1); {$I+}
  if IOResult<>0 then
   begin
     ReWrite(omzfile,1);
     s:='OMZ';
     BlockWrite(omzfile,s[1],3);
   end
  else
   begin
     While NOT(eof(omzfile)) do
      BlockRead(omzfile,s,255);
   end;
end;

Function Optimize(what :pFileZip) :Longint;
Type
  pPos =^tPos;
  tPos =RECORD
    pos :Dword;
    Upos :DWord;
    b :longint;
    k :byte;
    w :word;
    size :word;
    slide :pChar;
    txt :string;
    sel :boolean;
    next :pPos;
  end;

var
  back,back2 :array[1..25,1..80] of word;
  tmpf :file;
  done :Boolean;
  ch   :char;
  tmp,tmp2  :pPos;
  FirstPos :pPos;
  CurrPos  :pPos;
  TotalPos :Dword;
  ListPos  :Longint;
  i        :longint;

  Procedure GetPositions;
  var
    v :Longint;
    s :string;
    cc :longint;
  begin
    Assign(tmpf, TempFile);
    Reset(tmpf,1);

    cc:=0;
    While NOT(eof(tmpf)) DO
     begin
       new(tmp);
       if FirstPos=NIL then FirstPos:=tmp
       else
        begin
          tmp2:=firstpos;
          while tmp2^.next<>NIL do tmp2:=tmp2^.next;
          tmp2^.next:=tmp;
        end;
       tmp^.next:=NIL;

       tmp^.txt:='';
       BlockRead(tmpf, v, 4);
       tmp^.pos:=v;
       str(v:10, s);
       tmp^.txt:=tmp^.txt+s;
       BlockRead(tmpf, v, 4);
       tmp^.upos:=v;
       str(v:15, s);
       tmp^.txt:=tmp^.txt+s;
       BlockRead(tmpf, v, 4);
       tmp^.w:=v;
       BlockRead(tmpf, v, 4);
       tmp^.b:=v;
       BlockRead(tmpf, v, 4);
       tmp^.k:=v;
       BlockRead(tmpf, v, 4);
       tmp^.size:=v;
       str(v:15, s);
       tmp^.txt:=tmp^.txt+s;
       GetMem(tmp^.slide, v);
       BlockRead(tmpf, tmp^.slide^, v);
       tmp^.sel:=FALSE;
       inc(totalpos,1);
       inc(cc, 20+v);
       if cc>(FileSize(tmpf)-20) then break;
     end;

    Close(tmpf);
    Erase(tmpf);
  end;

  Procedure ShowPositions(count:longint);
  var
    cc,i :longint;
  begin
    tmp:=FirstPos;
    if count>totalpos then count:=totalpos;
    if count<1 then count:=1;
    cc:=1;
    if count>11 then
     begin
       While tmp<>NIL do
        begin
          if cc>count-11 then break;
          inc(cc,1);
          tmp:=tmp^.next;
        end;
     end;

    i:=0;
    While (tmp<>NIL) AND (i<11) do
     begin
       if cc+i=count then
        begin
          if tmp^.sel then
           htWrite(8+i,11,Yellow+BlueBG, '[X] '+tmp^.txt)
          else htWrite(8+i,11,Yellow+BlueBG, '[ ] '+tmp^.txt);
          HtAttr(8+i,11,1,60,White+CyanBG);
          CurrPos:=tmp;
        end
       else
        if tmp^.sel then
         htWrite(8+i,11,LightGray+BlueBG, '[X] '+tmp^.txt)
        else htWrite(8+i,11,LightGray+BlueBG, '[ ] '+tmp^.txt);

       inc(i,1);
       tmp:=tmp^.next;
     end;
  end;


begin
  result:=1;

  if what=NIL then exit;
  HtStoreToMem(1,1,CrtRows,CrtCols, back);

  unzip.zfs_ReachedBytes:=0;
  unzip.zfs_ToReachBytes:=what^.usize;
  unzip.zfs_NeededSize:=what^.usize;
  unzip.zfs_OutBuf:=NIL;
  unzip.zfs_OutOfs:=0;
  unzip.Outname:=TEMPFile;
  unzip.FirstDone:=FALSE;
  unzip.unzipfile (unzip.ZIP, what^.pos, what^.size, what^.kind-16,
                   0, 0, 0, 0, NIL, 0);

  FirstPos:=NIL;
  CurrPos:=NIL;
  TotalPos:=0;
  GetPositions;

  Box(5,11,17,60, White+BlueBG, DoubleBorder, ' ');
  HtWriteC(4,40, Yellow+BlueBG, ' '+what^.nom+' ');
  HtWrite(6,18, LightRed+BlueBG, 'Comp. Pos.    UnComp. Pos.    Seek info size');
  HtFill(7,11,1,60, LightRed+BlueBG, '');
  HtWrite(25,1, Black+LightGrayBG, 'ESC : Main menu - SPACE : Select - F5 : Optimize selected positions');

  listPos:=1;
  done:=FALSE;
  Repeat
    HtFill(8,11,14,60, White+BlueBG, ' ');
    ShowPositions(listpos);

    ch:=htReadKey(FK);
    case ch of
      #72  :begin               {Up Arrow}
              dec(listpos,1);
              if listpos<1 then listpos:=1;
            end;
      #80  :begin               {Down Arrow}
              inc(listpos,1);
              if listpos>TotalPos then listpos:=totalpos;
            end;

      #32  :begin
              currpos^.sel:=NOT(currpos^.sel);
              inc(listpos,1);
              if listpos>TotalPos then listpos:=totalpos;
            end;
      #63  :begin
              if FK then  {F5}
               begin
                 tmp:=FirstPos;
                 i:=0;
                 While tmp<>NIL do
                  begin
                    if tmp^.sel then inc(i,1);
                    tmp:=tmp^.next;
                  end;
                 if i=0 then
                  begin
                    HtStoreToMem(1,1,CrtRows,CrtCols, back2);
                    Box(12,15,3,50, White+RedBG, DoubleBorder, ' ');
                    HtWriteC(13,40, White+RedBG, 'ERROR : YOU HAVEN''T SELECTED ANY POSITION!');
                    HtReadKey(FK);
                    HtStoreToScr(1,1,CrtRows,CrtCols, back2);
                  end
                 else
                  begin
                    done:=TRUE;
                    Result:=30;
                  end;
               end;
            end;

      #27  :begin
               HtStoreToScr(1,1,CrtRows,CrtCols, back);
               result:=1;
               exit;
             end;
    end;
  until DONE;

  if OMZName='' then OMZname:=GetOMZName;

  OpenCreateOMZFile;
  BlockWrite(OMZfile, what^.nom[1], length(what^.nom));
  i:=0;
  BlockWrite(OMZfile, i, 1); {#0 terminated string}

  tmp:=FirstPos;
  While tmp<>NIL do
   begin
     tmp2:=tmp^.next;

     BlockWrite(OMZfile, tmp^.pos, 4);
     BlockWrite(OMZfile, tmp^.upos, 4);
     i:=(tmp^.k SHL 16)+tmp^.b;
     BlockWrite(OMZfile, i, 4);
     BlockWrite(OMZfile, tmp^.w, 2);
     BlockWrite(OMZfile, tmp^.size, 2);
     BlockWrite(OMZfile, tmp^.slide^, tmp^.size);

     FreeMem(tmp^.slide, tmp^.size);
     dispose(tmp);
     tmp:=tmp2;
   end;
  i:=255;
  BlockWrite(OMZfile, i, 1);

  Close(omzfile);

  HtStoreToScr(1,1,CrtRows,CrtCols, back);
end;


function OptimizeFiles :longint;
var tmp :pFileZip;
begin
  result:=0;
  if FirstOpti=NIL then exit;
  tmp:=FirstOpti;
  While tmp<>NIL do
   begin
     if (tmp^.kind=8+16) then result:=Optimize(tmp);
     if result=1 then break;  {Go to Main Menu}
     tmp:=tmp^.next;
   end;
  result:=1;
end;



var
  Done :Boolean;
  res  :longint;
  ch   :char;

begin
  Unzip.Seekinginfo:=TRUE;

  InitScreen;

  DrawBackground;

  TEMPFile:=GetEnv('TEMP');
  if TempFile='' then tempFile:='c:\';
  if tempfile[length(tempfile)] IN ['\','/'] then tempFile:=tempfile+'~$TEMP$~.___'
                                             else tempfile:=tempfile+'\'+'~$TEMP$~.___';

  Done:=FALSE;
  res:=1; {Main Menu}
  Repeat
    case res of
      0    :Done:=TRUE;         {EXIT}
      1    :res:=MainMenu;      {MAIN MENU}
      2    :res:=SelectZIP;     {SELECT A ZIP TO PROCESS}
      3    :res:=MainMenu;
      10   :res:=ProcessZIP;    {SELECT FILES TO OPTIMIZE}
      20   :res:=OptimizeFiles; {OPTIMIZE THE FILES}
    end;
  Until Done;

  CloseScreen;
  WriteLN(zipname);
end.
